/* passgen.c
 *
 * Simple password generator
 * Tony Howat tony@i-r-genius.com 22/01/04
 *
 */
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#define UNIXDICT "/usr/share/dict/words"

char *generate_password(char *buffer, int length)
{
  FILE *in;
  int i=0;
  int dlength=0;

  in=fopen(UNIXDICT,"r");
  if(!in)
    exit(1);
  
  fseek(in,0,SEEK_END);
  dlength=ftell(in);
  fseek(in,rand() % dlength,SEEK_SET);

  while(i!=(length-1))
  {
    int c;
    c=fgetc(in);

    if(feof(in) | c=='\n')
    {
      fseek(in,rand() % dlength,SEEK_SET);
      continue;
    }

    if(isalpha(c))
    {
      buffer[i]=c;
      ++i;
    } 
  }

  buffer[i]='\0';

  fclose(in);
  return buffer;
}

int main(void)
{
  char out[8];

  srand(time(NULL));
  srand(rand()*getpid());

  printf("%s%02i",generate_password(out,8),(rand()%100));
  return 0;
}
